#!/usr/bin/python3

import sys  # sys нужен для передачи argv в QApplication
from PyQt5 import QtCore, QtGui, QtWidgets
from PyQt5.QtWidgets import (QWidget, QHBoxLayout, QLabel, QApplication, QPushButton, QLineEdit,
    QInputDialog,)
import numpy as np
from PIL import Image, ImageDraw, ImageFilter
import matplotlib.pyplot as plt
import matplotlib.image as mpimg
import VariablesTest
#from matplotlib.pyplot import yscale
#from matplotlib.pyplot import xscale
import colorsys 
import glob, os

class ExampleApp(QtWidgets.QMainWindow, VariablesTest.Ui_dialog):
    def __init__(self):
        # Это здесь нужно для доступа к переменным, методам
        # и т.д. в файле design.py
        super().__init__()
        self.setupUi(self)  # Это нужно для инициализации нашего дизайна 

    def Syow_test(self):

        
        lineEditValue = self.lineEdit.text()
        ##print(lineEditValue)


        size = 1024, 1024


        for infile in glob.glob(lineEditValue):
            file, ext = os.path.splitext(infile)
           # print(file,ext)
            im = Image.open(infile)
            im.thumbnail(size, Image.ANTIALIAS)
            im1 = im.filter(ImageFilter.GaussianBlur(radius=4))
            im1.save(file + "_blurred"+ ext)

        

        image = Image.open(file + "_blurred"+ ext)  # Открываем изображение
 #       image = Image.open(lineEditValue)  # Открываем изображение
        draw = ImageDraw.Draw(image)  # Создаем инструмент для рисования
        width = image.size[0]  # Определяем ширину
        height = image.size[1]  # Определяем высоту
        pix = image.load()  # Выгружаем значения пикселей

        ##print(height, width)
        HI=height/1076
        WI=width/1521

        Delta_X= self.lineEdit_x.text()
        Delta_Y= self.lineEdit_y.text()

       # Координаты

        xx=int(Delta_X)
        yy=int(Delta_Y)
       
        x1=150 + xx
        x2=360 + xx
        x3=580 + xx
        x4=815 + xx
        y1=1000 + yy
        y2=825 + yy
        y3=660 + yy
        y4=500 + yy
        y5=320 + yy
        y6=150 + yy

        X=np.array([[HI*x1, HI*x2, HI*x3, HI*x4], [WI*y1, WI*y2, WI*y3, WI*y4, WI*y5, WI*y6]], dtype=object)


        R1=[(X [1][0]), (X [0][0])]
        R2=[(X [1][1]), (X [0][0])]
        R3=[(X [1][2]), (X [0][0])]
    

        R4=[(X [1][3]), (X [0][0])]
        R5=[(X [1][4]), (X [0][0])]
        R6=[(X [1][5]), (X [0][0])]

        G1=[(X [1][0]), (X [0][1])]
        G2=[(X [1][1]), (X [0][1])]
        G3=[(X [1][2]), (X [0][1])]
        G4=[(X [1][3]), (X [0][1])]
        G5=[(X [1][4]), (X [0][1])]
        G6=[(X [1][5]), (X [0][1])]

        B1=[(X [1][0]), (X [0][2])]
        B2=[(X [1][1]), (X [0][2])]
        B3=[(X [1][2]), (X [0][2])]
        B4=[(X [1][3]), (X [0][2])]
        B5=[(X [1][4]), (X [0][2])]
        B6=[(X [1][5]), (X [0][2])]

        W1=[(X [1][0]), (X [0][3])]
        W2=[(X [1][1]), (X [0][3])]
        W3=[(X [1][2]), (X [0][3])]
        W4=[(X [1][3]), (X [0][3])]
        W5=[(X [1][4]), (X [0][3])]
        W6=[(X [1][5]), (X [0][3])]

        R1h=pix[(X [1][0]), (X [0][0])]
        R2h=pix[(X [1][1]), (X [0][0])]
        R3h=pix[(X [1][2]), (X [0][0])]
        R4h=pix[(X [1][3]), (X [0][0])]
        R5h=pix[(X [1][4]), (X [0][0])]
        R6h=pix[(X [1][5]), (X [0][0])]

        G1h=pix[(X [1][0]), (X [0][1])]
        G2h=pix[(X [1][1]), (X [0][1])]
        G3h=pix[(X [1][2]), (X [0][1])]
        G4h=pix[(X [1][3]), (X [0][1])]
        G5h=pix[(X [1][4]), (X [0][1])]
        G6h=pix[(X [1][5]), (X [0][1])]

        B1h=pix[(X [1][0]), (X [0][2])]
        B2h=pix[(X [1][1]), (X [0][2])]
        B3h=pix[(X [1][2]), (X [0][2])]
        B4h=pix[(X [1][3]), (X [0][2])]
        B5h=pix[(X [1][4]), (X [0][2])]
        B6h=pix[(X [1][5]), (X [0][2])]

        W1h=pix[(X [1][0]), (X [0][3])]
        W2h=pix[(X [1][1]), (X [0][3])]
        W3h=pix[(X [1][2]), (X [0][3])]
        W4h=pix[(X [1][3]), (X [0][3])]
        W5h=pix[(X [1][4]), (X [0][3])]
        W6h=pix[(X [1][5]), (X [0][3])]

        Rmid1=((pix[((R1 [0]), (R1 [1]))][0])**2+(pix[((R1 [0]), (R1 [1]))][1])**2+(pix[((R1 [0]), (R1 [1]))][2])**2)**0.5
        Rmid2=((pix[((R2 [0]), (R2 [1]))][0])**2+(pix[((R2 [0]), (R2 [1]))][1])**2+(pix[((R2 [0]), (R2 [1]))][2])**2)**0.5
        Rmid3=((pix[((R3 [0]), (R3 [1]))][0])**2+(pix[((R3 [0]), (R3 [1]))][1])**2+(pix[((R3 [0]), (R3 [1]))][2])**2)**0.5
        Rmid4=((pix[((R4 [0]), (R4 [1]))][0])**2+(pix[((R4 [0]), (R4 [1]))][1])**2+(pix[((R4 [0]), (R4 [1]))][2])**2)**0.5
        Rmid5=((pix[((R5 [0]), (R5 [1]))][0])**2+(pix[((R5 [0]), (R5 [1]))][1])**2+(pix[((R5 [0]), (R5 [1]))][2])**2)**0.5
        Rmid6=((pix[((R6 [0]), (R6 [1]))][0])**2+(pix[((R6 [0]), (R6 [1]))][1])**2+(pix[((R6 [0]), (R6 [1]))][2])**2)**0.5
        
        Gmid1=((pix[((G1 [0]), (G1 [1]))][0])**2+(pix[((G1 [0]), (G1 [1]))][1])**2+(pix[((G1 [0]), (G1 [1]))][2])**2)**0.5
        Gmid2=((pix[((G2 [0]), (G2 [1]))][0])**2+(pix[((G2 [0]), (G2 [1]))][1])**2+(pix[((G2 [0]), (G2 [1]))][2])**2)**0.5
        Gmid3=((pix[((G3 [0]), (G3 [1]))][0])**2+(pix[((G3 [0]), (G3 [1]))][1])**2+(pix[((G3 [0]), (G3 [1]))][2])**2)**0.5
        Gmid4=((pix[((G4 [0]), (G4 [1]))][0])**2+(pix[((G4 [0]), (G4 [1]))][1])**2+(pix[((G4 [0]), (G4 [1]))][2])**2)**0.5
        Gmid5=((pix[((G5 [0]), (G5 [1]))][0])**2+(pix[((G5 [0]), (G5 [1]))][1])**2+(pix[((G5 [0]), (G5 [1]))][2])**2)**0.5
        Gmid6=((pix[((G6 [0]), (G6 [1]))][0])**2+(pix[((G6 [0]), (G6 [1]))][1])**2+(pix[((G6 [0]), (G6 [1]))][2])**2)**0.5

        Bmid1=((pix[((B1 [0]), (B1 [1]))][0])**2+(pix[((B1 [0]), (B1 [1]))][1])**2+(pix[((B1 [0]), (B1 [1]))][2])**2)**0.5
        Bmid2=((pix[((B2 [0]), (B2 [1]))][0])**2+(pix[((B2 [0]), (B2 [1]))][1])**2+(pix[((B2 [0]), (B2 [1]))][2])**2)**0.5
        Bmid3=((pix[((B3 [0]), (B3 [1]))][0])**2+(pix[((B3 [0]), (B3 [1]))][1])**2+(pix[((B3 [0]), (B3 [1]))][2])**2)**0.5
        Bmid4=((pix[((B4 [0]), (B4 [1]))][0])**2+(pix[((B4 [0]), (B4 [1]))][1])**2+(pix[((B4 [0]), (B4 [1]))][2])**2)**0.5
        Bmid5=((pix[((B5 [0]), (B5 [1]))][0])**2+(pix[((B5 [0]), (B5 [1]))][1])**2+(pix[((B5 [0]), (B5 [1]))][2])**2)**0.5
        Bmid6=((pix[((B6 [0]), (B6 [1]))][0])**2+(pix[((B6 [0]), (B6 [1]))][1])**2+(pix[((B6 [0]), (B6 [1]))][2])**2)**0.5

        Wmid1=((((pix[((W1 [0]), (W1 [1]))][0])**2+(pix[((W1 [0]), (W1 [1]))][1])**2+(pix[((W1 [0]), (W1 [1]))][2])**2))/3)**0.5
        Wmid2=((((pix[((W2 [0]), (W2 [1]))][0])**2+(pix[((W2 [0]), (W2 [1]))][1])**2+(pix[((W2 [0]), (W2 [1]))][2])**2))/3)**0.5
        Wmid3=((((pix[((W3 [0]), (W3 [1]))][0])**2+(pix[((W3 [0]), (W3 [1]))][1])**2+(pix[((W3 [0]), (W3 [1]))][2])**2))/3)**0.5
        Wmid4=((((pix[((W4 [0]), (W4 [1]))][0])**2+(pix[((W4 [0]), (W4 [1]))][1])**2+(pix[((W4 [0]), (W4 [1]))][2])**2))/3)**0.5
        Wmid5=((((pix[((W5 [0]), (W5 [1]))][0])**2+(pix[((W5 [0]), (W5 [1]))][1])**2+(pix[((W5 [0]), (W5 [1]))][2])**2))/3)**0.5
        Wmid6=((((pix[((W6 [0]), (W6 [1]))][0])**2+(pix[((W6 [0]), (W6 [1]))][1])**2+(pix[((W6 [0]), (W6 [1]))][2])**2))/3)**0.5



        Z=R1h

        hsv_img = colorsys.rgb_to_hsv (int (Z[0]), int (Z[1]), int (Z[2]))
        HCV_0=(round(100*hsv_img[0])/100, round(100*hsv_img[1])/100, round(100*hsv_img[2])/100)
        HH=round(360*(HCV_0[0]))
        ##print("H R0 G119 B241 :", Z, HH)
        ##print("S" , round(100*(HCV_0[1])))
        ##print("V", round((HCV_0[2])/2.55))
        if (HH>300):        
            DDR1=HH-360
        else:
            DDR1=HH            
        ##print(DDR1)

        Z=R2h
        
        hsv_img = colorsys.rgb_to_hsv (int (Z[0]), int (Z[1]), int (Z[2]))
        HCV_0=(round(100*hsv_img[0])/100, round(100*hsv_img[1])/100, round(100*hsv_img[2])/100)
        HH=round(360*(HCV_0[0]))
        ##print("H R0 G119 B241 :", Z, HH)
        ##print("S" , round(100*(HCV_0[1])))
        ##print("V", round((HCV_0[2])/2.55))
        if (HH>300):
            DDR2=HH-360
        else:
            DDR2=HH
        #print(DDR2)

        Z=R3h
        
        hsv_img = colorsys.rgb_to_hsv (int (Z[0]), int (Z[1]), int (Z[2]))
        HCV_0=(round(100*hsv_img[0])/100, round(100*hsv_img[1])/100, round(100*hsv_img[2])/100)
        HH=round(360*(HCV_0[0]))
        #print("H R0 G119 B241 :", Z, HH)
        #print("S" , round(100*(HCV_0[1])))
        #print("V", round((HCV_0[2])/2.55))
        if (HH>300):
            DDR3=HH-360
        else:
            DDR3=HH
        #print(DDR3)
        
        Z=R4h

        hsv_img = colorsys.rgb_to_hsv (int (Z[0]), int (Z[1]), int (Z[2]))
        HCV_0=(round(100*hsv_img[0])/100, round(100*hsv_img[1])/100, round(100*hsv_img[2])/100)
        HH=round(360*(HCV_0[0]))
        #print("H R0 G119 B241 :", Z, HH)
        #print("S" , round(100*(HCV_0[1])))
        #print("V", round((HCV_0[2])/2.55))
        if (HH>300):
            DDR4=HH-360
        else:
            DDR4=HH
        #print(DDR4)
        
        Z=R5h

        hsv_img = colorsys.rgb_to_hsv (int (Z[0]), int (Z[1]), int (Z[2]))
        HCV_0=(round(100*hsv_img[0])/100, round(100*hsv_img[1])/100, round(100*hsv_img[2])/100)
        HH=round(360*(HCV_0[0]))
        #print("H R0 G119 B241 :", Z, HH)
        #print("S" , round(100*(HCV_0[1])))
        #print("V", round((HCV_0[2])/2.55))
        if (HH>300):
            DDR5=HH-360
        else:
            DDR5=HH
        #print(DDR5)
        
        Z=R6h
        
        hsv_img = colorsys.rgb_to_hsv (int (Z[0]), int (Z[1]), int (Z[2]))
        HCV_0=(round(100*hsv_img[0])/100, round(100*hsv_img[1])/100, round(100*hsv_img[2])/100)
        HH=round(360*(HCV_0[0]))
        #print("H R0 G119 B241 :", Z, HH)
        #print("S" , round(100*(HCV_0[1])))
        #print("V", round((HCV_0[2])/2.55))
        if (HH>300):
            DDR6=HH-360
        else:
            DDR6=HH
        #print(DDR6)


        Z=G1h

        hsv_img = colorsys.rgb_to_hsv (int (Z[0]), int (Z[1]), int (Z[2]))
        HCV_0=(round(100*hsv_img[0])/100, round(100*hsv_img[1])/100, round(100*hsv_img[2])/100)
        HH=round(360*(HCV_0[0]))
        #print("H G0 G119 B241 :", Z, HH)
        #print("S" , round(100*(HCV_0[1])))
        #print("V", round((HCV_0[2])/2.55))
        DDG1=HH-119
        #print(DDG1)

        Z=G2h
        
        hsv_img = colorsys.rgb_to_hsv (int (Z[0]), int (Z[1]), int (Z[2]))
        HCV_0=(round(100*hsv_img[0])/100, round(100*hsv_img[1])/100, round(100*hsv_img[2])/100)
        HH=round(360*(HCV_0[0]))
        #print("H G0 G119 B241 :", Z, HH)
        #print("S" , round(100*(HCV_0[1])))
        #print("V", round((HCV_0[2])/2.55))
        DDG2=HH-119
        #print(DDG2)
        
        Z=G3h

        hsv_img = colorsys.rgb_to_hsv (int (Z[0]), int (Z[1]), int (Z[2]))
        HCV_0=(round(100*hsv_img[0])/100, round(100*hsv_img[1])/100, round(100*hsv_img[2])/100)
        HH=round(360*(HCV_0[0]))
        #print("H G0 G119 B241 :", Z, HH)
        #print("S" , round(100*(HCV_0[1])))
        #print("V", round((HCV_0[2])/2.55))
        DDG3=HH-119
        #print(DDG3)
        
        Z=G4h
        
        hsv_img = colorsys.rgb_to_hsv (int (Z[0]), int (Z[1]), int (Z[2]))
        HCV_0=(round(100*hsv_img[0])/100, round(100*hsv_img[1])/100, round(100*hsv_img[2])/100)
        HH=round(360*(HCV_0[0]))
        #print("H G0 G119 B241 :", Z, HH)
        #print("S" , round(100*(HCV_0[1])))
        #print("V", round((HCV_0[2])/2.55))
        DDG4=HH-119
        #print(DDG4)
        
        Z=G5h
        
        hsv_img = colorsys.rgb_to_hsv (int (Z[0]), int (Z[1]), int (Z[2]))
        HCV_0=(round(100*hsv_img[0])/100, round(100*hsv_img[1])/100, round(100*hsv_img[2])/100)
        HH=round(360*(HCV_0[0]))
        #print("H G0 G119 B241 :", Z, HH)
        #print("S" , round(100*(HCV_0[1])))
        #print("V", round((HCV_0[2])/2.55))
        DDG5=HH-119
        #print(DDG5)
        
        Z=G6h
        
        hsv_img = colorsys.rgb_to_hsv (int (Z[0]), int (Z[1]), int (Z[2]))
        HCV_0=(round(100*hsv_img[0])/100, round(100*hsv_img[1])/100, round(100*hsv_img[2])/100)
        HH=round(360*(HCV_0[0]))
        #print("H G0 G119 B241 :", Z, HH)
        #print("S" , round(100*(HCV_0[1])))
        #print("V", round((HCV_0[2])/2.55))
        DDG6=HH-119
        #print(DDG6)
        
        Z=B1h
        
        hsv_img = colorsys.rgb_to_hsv (int (Z[0]), int (Z[1]), int (Z[2]))
        HCV_0=(round(100*hsv_img[0])/100, round(100*hsv_img[1])/100, round(100*hsv_img[2])/100)
        HH=round(360*(HCV_0[0]))
        #print("H R0 G119 B241 :", Z, HH)
        #print("S" , round(100*(HCV_0[1])))
        #print("V", round((HCV_0[2])/2.55))
        DDB1=HH-241
        #print(DDB1)
        
        Z=B2h

        hsv_img = colorsys.rgb_to_hsv (int (Z[0]), int (Z[1]), int (Z[2]))
        HCV_0=(round(100*hsv_img[0])/100, round(100*hsv_img[1])/100, round(100*hsv_img[2])/100)
        HH=round(360*(HCV_0[0]))
        #print("H R0 G119 B241 :", Z, HH)
        #print("S" , round(100*(HCV_0[1])))
        #print("V", round((HCV_0[2])/2.55))
        DDB2=HH-241
        #print(DDB2)
        
        Z=B3h
        
        hsv_img = colorsys.rgb_to_hsv (int (Z[0]), int (Z[1]), int (Z[2]))
        HCV_0=(round(100*hsv_img[0])/100, round(100*hsv_img[1])/100, round(100*hsv_img[2])/100)
        HH=round(360*(HCV_0[0]))
        #print("H R0 G119 B241 :", Z, HH)
        #print("S" , round(100*(HCV_0[1])))
        #print("V", round((HCV_0[2])/2.55))
        DDB3=HH-241
        #print(DDB3)
        
        Z=B4h
        
        hsv_img = colorsys.rgb_to_hsv (int (Z[0]), int (Z[1]), int (Z[2]))
        HCV_0=(round(100*hsv_img[0])/100, round(100*hsv_img[1])/100, round(100*hsv_img[2])/100)
        HH=round(360*(HCV_0[0]))
        #print("H R0 G119 B241 :", Z, HH)
        #print("S" , round(100*(HCV_0[1])))
        #print("V", round((HCV_0[2])/2.55))
        DDB4=HH-241
        #print(DDB4)
        
        Z=B5h
    
        hsv_img = colorsys.rgb_to_hsv (int (Z[0]), int (Z[1]), int (Z[2]))
        HCV_0=(round(100*hsv_img[0])/100, round(100*hsv_img[1])/100, round(100*hsv_img[2])/100)
        HH=round(360*(HCV_0[0]))
        #print("H R0 G119 B241 :", Z, HH)
        #print("S" , round(100*(HCV_0[1])))
        #print("V", round((HCV_0[2])/2.55))
        DDB5=HH-241
        #print(DDB5)
        
        Z=B6h
        
        hsv_img = colorsys.rgb_to_hsv (int (Z[0]), int (Z[1]), int (Z[2]))
        HCV_0=(round(100*hsv_img[0])/100, round(100*hsv_img[1])/100, round(100*hsv_img[2])/100)
        HH=round(360*(HCV_0[0]))
        #print("H R0 G119 B241 :", Z, HH)
        #print("S" , round(100*(HCV_0[1])))
        #print("V", round((HCV_0[2])/2.55))
        DDB6=HH-241
        #print(DDB6)
        
        x = [15, 20, 30, 50, 75, 100]
        Wmid = [Wmid1, Wmid2, Wmid3, Wmid4, Wmid5, Wmid6]
        Rmid = [Rmid1, Rmid2, Rmid3, Rmid4, Rmid5, Rmid6]
        Gmid = [Gmid1, Gmid2, Gmid3, Gmid4, Gmid5, Gmid6]
        Bmid = [Bmid1, Bmid2, Bmid3, Bmid4, Bmid5, Bmid6]
        
        k=0.98
        Gamma= 1.2
        DD=10
        
        Gamma_curve=[k*15**Gamma+DD, k*20**Gamma+DD, k*30**Gamma+DD, k*50**Gamma+DD, k*75**Gamma+DD, k*100**Gamma+DD ]
        DDR=[DDR1,DDR2,DDR3,DDR4,DDR5,DDR6]
        DDG=[DDG1,DDG2,DDG3,DDG4,DDG5,DDG6]
        DDB=[DDB1,DDB2,DDB3,DDB4,DDB5,DDB6]
        
        plt.plot(x, Wmid, 'k', x, Rmid, 'r:',x, Gmid, 'g:',x, Bmid, 'b:', x, DDR, '.-r', x, DDG, '.-g', x, DDB, '.-b', x, Gamma_curve, 'y')
        #xscale('log')
        #yscale('log')
        plt.title(r'Цветопередача') 
        plt.xlabel('Эталон цвета %')
        plt.ylabel('Воспроизводимый цвет RGB')
        plt.grid(True)
        plt.savefig('graph.png') 
        
    
#plt.legend()

        #plt.show()
        plt.close()
        self.label_img.setPixmap(QtGui.QPixmap("graph.png"))

        ##############################################################


    def Syow_kadr(self):
        
        lineEditValue = self.lineEdit.text()
        if (lineEditValue == '1.png') :
            
        ##print(lineEditValue)
            
        
            self.label_img.setPixmap(QtGui.QPixmap(lineEditValue))
   
        else:
            image = Image.open(lineEditValue)  # Открываем изображение
            draw = ImageDraw.Draw(image)  # Создаем инструмент для рисования
            width = image.size[0]  # Определяем ширину
            height = image.size[1]  # Определяем высоту
            pix = image.load()  # Выгружаем значения пикселей

        ##print(height, width)
            HI=height/1076
            WI=width/1521
            Delta_X= self.lineEdit_x.text()
            Delta_Y= self.lineEdit_y.text()
 # Координаты

            xx=int(Delta_X)
            yy=int(Delta_Y)
            x1=(150 + xx)*HI
            x2=(360 + xx)*HI
            x3=(580 + xx)*HI
            x4=(815 + xx)*HI
            y1=(1000 + yy)*WI
            y2=(825 + yy)*WI
            y3=(660 + yy)*WI
            y4=(500 + yy)*WI
            y5=(320 + yy)*WI
            y6=(150 + yy)*WI
            
            im = plt.imread(lineEditValue)
            implot = plt.imshow(im)
            plt.plot(0, 0, 'k:', y1, x1,'co', y1, x2,'ro', y1, x3,'ro', y1, x4,'co',
            + y2, x1,'ro', y2, x2, 'ro', y2, x3,'ro', y2, x4,'ro',
            + y3, x1,'ro', y3, x2, 'ro', y3, x3,'ro', y3, x4,'ro',
            + y4, x1,'ro', y4, x2, 'ro', y4, x3,'ro', y4, x4,'ro',
            + y5, x1,'ro', y5, x2, 'ro', y5, x3,'ro', y5, x4,'ro',
            + y6, x1,'co', y6, x2, 'ro', y6, x3,'ro', y6, x4,'co',)
            plt.savefig('gr.png')

            self.label_img.setPixmap(QtGui.QPixmap('gr.png'))
            plt.close()

                
############################################################################

def main():
    app = QtWidgets.QApplication(sys.argv)  # Новый экземпляр QApplication
    window = ExampleApp()  # Создаём объект класса ExampleApp
    window.show()  # Показываем окно
    app.exec_()  # и запускаем приложение

if __name__ == '__main__':  # Если мы запускаем файл напрямую, а не импортируем
    main()  # то запускаем функцию main()


